; VXDSDLL.ASM
; A sort of replacement DLL for ntvdm.exe

.386
.model flat,stdcall
option casemap:none
include windows.inc
include user32.inc
include kernel32.inc
includelib user32.lib
includelib kernel32.lib

.data
        
        CallBuffer      dd              8 DUP (0)
        ReturnValue     dd              0
        hFileMap        dd              0
        hFileView       dd              0
        MyDmaInfo       db              12 DUP (0)

        ; 0 = DWORD, 1 = WORD and 2 = BYTE
        RegTypeList     db              0,1,2,2,0,1,2,2,\
                                        0,1,2,2,0,1,2,2,\
                                        1,0,1,0,1,1,0,1,\
                                        1,0,1,1,0,1,0,0
        RegOffsetList   db              1ch,1ch,1ch,1dh,10h,10h,10h,11h,\
                                        18h,18h,18h,19h,14h,14h,14h,15h,\
                                        34h,30h,30h,08h,08h,3ch,04h,04h,\
                                        38h,00h,00h,28h,24h,24h,00h,00h

        ;  CARRY, PARITY, AUX, ZERO, SIGN, TRAP, INT, DIR, OFLOW
        FlagBitList     db              00h,02h,04h,06h,07h,08h,09h,0ah,0bh

        SharedMemName   db              "PooPooWeeWeeHello",0

        ADDR_PM         equ             0
        ADDR_V86        equ             1
        ADDR_PHYSICAL   equ             2
        ADDR_LINEAR     equ             3

.code

DllEntry        proc hInstDLL:HINSTANCE,reason:DWORD,reserved1:DWORD        
        
        .if reason==DLL_PROCESS_ATTACH
                invoke  OpenFileMapping,FILE_MAP_ALL_ACCESS,FALSE,\
                        addr SharedMemName
                .if eax!=NULL
                        mov     hFileMap,eax
                        invoke  MapViewOfFile,eax,FILE_MAP_ALL_ACCESS,0,0,32
                        mov     hFileView,eax
                .endif
        .elseif reason==DLL_PROCESS_DETACH
                invoke  UnmapViewOfFile,hFileView
                invoke  CloseHandle,hFileMap
        .endif
        mov     eax,TRUE
        ret

DllEntry        endp

PasshVxD        proc VxDHandle:DWORD

        mov     eax,VxDHandle
        mov     ebx,hFileView
        mov     dword ptr[ebx],eax
        ret

PasshVxD        endp

CreateMem       proc

        invoke  CreateFileMapping,INVALID_HANDLE_VALUE,NULL,PAGE_READWRITE,\
                0,4112,addr SharedMemName
        mov     hFileMap,eax
        invoke  MapViewOfFile,eax,FILE_MAP_ALL_ACCESS,0,0,32
        mov     hFileView,eax
        ret

CreateMem       endp

vGetRegister    proc RegNum:DWORD

        

        mov     ebx,RegNum
        mov     dword ptr[CallBuffer],0
        xor     eax,eax
        mov     al,byte ptr[offset RegTypeList+ebx]
        mov     dword ptr[CallBuffer+04h],eax
        mov     al,byte ptr[offset RegOffsetList+ebx]
        mov     dword ptr[CallBuffer+08h],eax
        mov     edx,hFileView
        invoke  DeviceIoControl,[edx],4,addr CallBuffer,12,addr ReturnValue,\
                4,NULL,NULL
        mov     eax,ReturnValue
        ret

vGetRegister    endp

vSetRegister    proc RegNum:DWORD,Value:DWORD

        

        mov     ebx,RegNum
        mov     dword ptr[CallBuffer],1
        xor     eax,eax
        mov     al,byte ptr[offset RegTypeList+ebx]
        mov     dword ptr[CallBuffer+04h],eax
        mov     al,byte ptr[offset RegOffsetList+ebx]
        mov     dword ptr[CallBuffer+08h],eax
        mov     eax,Value
        mov     dword ptr[CallBuffer+0ch],eax
        mov     edx,hFileView
        invoke  DeviceIoControl,[edx],4,addr CallBuffer,16,NULL,NULL,NULL,\
                NULL
        ret

vSetRegister    endp

vGetFlag        proc FlagNum:DWORD

        

        ; SNOZZBERRY
        ret

vGetFlag        endp

vSetFlag        proc FlagNum:DWORD,Value:DWORD

        

        ; SNOZZBERRY
        ret

vSetFlag        endp

VDDHookDMA      proc iChannel:DWORD,lpDMACallback:DWORD

        

        push    edx
        mov     eax,iChannel
        mov     edx,hFileView
        mov     dword ptr[CallBuffer],eax
        mov     eax,lpDMACallback
        mov     dword ptr[edx+0ch],eax
        invoke  DeviceIoControl,[edx],8,addr CallBuffer,4,NULL,NULL,NULL,NULL
        pop     edx
        ret

VDDHookDMA      endp

VDDUnhookDMA    proc iChannel:DWORD

        

        mov     eax,iChannel
        mov     dword ptr[CallBuffer],eax
        mov     edx,hFileView
        invoke  DeviceIoControl,[edx],15,addr CallBuffer,4,NULL,NULL,NULL,\
                NULL
        ret

VDDUnhookDMA    endp

VDDHookIRQ      proc IRQNum:BYTE        

        movzx   eax,IRQNum
        mov     dword ptr[CallBuffer],eax
        mov     edx,hFileView
        invoke  DeviceIoControl,[edx],16,addr CallBuffer,4,NULL,NULL,NULL,\
                NULL
        ret

VDDHookIRQ      endp

VDDUnhookIRQ    proc IRQNum:DWORD

        

        mov     eax,IRQNum
        mov     dword ptr[CallBuffer],eax
        mov     edx,hFileView
        invoke  DeviceIoControl,[edx],17,addr CallBuffer,4,NULL,NULL,NULL,\
                NULL
        ret

VDDUnhookIRQ    endp

VDDQueryDMA     proc hVdd:WORD,iChannel:WORD,lpDmaInfo:DWORD

        push    edx
        movzx   eax,iChannel
        mov     dword ptr[CallBuffer],eax
        mov     eax,lpDmaInfo
        mov     dword ptr[CallBuffer+04h],eax
        mov     edx,hFileView
        invoke  DeviceIoControl,[edx],6,addr CallBuffer,8,addr ReturnValue,\
                4,NULL,NULL
        mov     eax,ReturnValue
        pop     edx
        ret

VDDQueryDMA     endp

VDDSetDMA       proc hVdd:WORD,iChannel:WORD,fDMA:WORD,buffer:DWORD

        

        invoke  VDDQueryDMA,NULL,iChannel,addr MyDmaInfo
        movzx   eax,fDMA
        mov     ebx,buffer

        test    eax,1
        jz      NoWriteAddr
        mov     cx,word ptr[ebx] ; addr
        mov     word ptr[MyDmaInfo],cx
NoWriteAddr:

        test    eax,2
        jz      NoWriteCount
        mov     cx,word ptr[ebx+02h] ; count
        mov     word ptr[MyDmaInfo+02h],cx
NoWriteCount:

        test    eax,4
        jz      NoWritePage
        mov     cx,word ptr[ebx+04h] ; page
        mov     word ptr[MyDmaInfo+04h],cx
NoWritePage:

        test    eax,8
        jz      NoWriteStatus
        mov     cl,byte ptr[ebx+06h] ; status
        mov     byte ptr[MyDmaInfo+06h],cl
NoWriteStatus:

        movzx   eax,iChannel
        mov     dword ptr[CallBuffer],eax
        mov     eax,offset MyDmaInfo
        mov     dword ptr[CallBuffer+04h],eax
        mov     edx,hFileView
        invoke  DeviceIoControl,[edx],7,addr CallBuffer,8,addr ReturnValue,\
                4,NULL,NULL
        mov     eax,ReturnValue
        ret

VDDSetDMA       endp

VDDRequestDMA   proc hVdd:WORD,iChannel:WORD,buffer:DWORD,buflength:DWORD

        

        ; SNOZZBERRY get this to do something
        ret

VDDRequestDMA   endp

VDDSimulateInterrupt    proc MasterOrSlave:WORD,intLine:BYTE,intcount:WORD

        

        movzx   ecx,intcount
ThisLoop:
        push    ecx
        mov     edx,hFileView
        movzx   eax,intLine
        mov     dword ptr[CallBuffer],eax
        invoke  DeviceIoControl,[edx],5,addr CallBuffer,4,NULL,NULL,NULL,NULL
        pop     ecx
        loop    ThisLoop
        ret

VDDSimulateInterrupt    endp

VDDInstallIOHook        proc hVdd:WORD,cbPortRange:WORD,lpPortRange:DWORD,handlers:DWORD

        

        push    ebx
        push    edx
        mov     eax,handlers
        mov     ebx,hFileView
        mov     ecx,dword ptr[eax]
        mov     dword ptr[ebx+04h],ecx
        mov     ecx,dword ptr[eax+10h]
        mov     dword ptr[ebx+08h],ecx
        movzx   eax,hVdd
        mov     dword ptr[CallBuffer],eax
        movzx   eax,cbPortRange
        mov     dword ptr[CallBuffer+04h],eax
        mov     eax,lpPortRange
        mov     dword ptr[CallBuffer+08h],eax
        mov     eax,handlers
        mov     dword ptr[CallBuffer+0ch],eax
        mov     edx,hFileView
        invoke  DeviceIoControl,[edx],9,addr CallBuffer,16,NULL,NULL,NULL,\
                NULL
        pop     edx
        pop     ebx
        mov     eax,TRUE
        ret

VDDInstallIOHook        endp

VDDDeInstallIOHook      proc hVdd:WORD,cbPortRange:WORD,lpPortRange:DWORD

        

        movzx   eax,hVdd
        mov     dword ptr[CallBuffer],eax
        movzx   eax,cbPortRange
        mov     dword ptr[CallBuffer+04h],eax
        mov     eax,lpPortRange
        mov     dword ptr[CallBuffer+08h],eax
        mov     edx,hFileView
        invoke  DeviceIoControl,[edx],10,addr CallBuffer,12,NULL,NULL,NULL,\
                NULL
        mov     eax,TRUE
        ret

VDDDeInstallIOHook      endp

VDDInstallUserHook      proc hVdd:WORD,hcreat:DWORD,hdestry:DWORD,hblok:DWORD,hresum:DWORD

        

        push    ebx
        mov     ebx,hFileView
        mov     eax,hcreat
        mov     dword ptr[ebx+10h],eax
        mov     eax,hdestry
        mov     dword ptr[ebx+14h],eax
        mov     eax,TRUE
        pop     ebx
        ret

VDDInstallUserHook      endp

VDDDeInstallUserHook    proc hVdd:WORD

        

        push    ebx
        mov     ebx,hFileView
        xor     eax,eax
        mov     dword ptr[ebx+10h],eax
        mov     dword ptr[ebx+14h],eax
        mov     eax,TRUE
        pop     ebx
        ret

VDDDeInstallUserHook    endp

VDDTerminateVDM proc

        

        mov     edx,hFileView
        invoke  DeviceIoControl,[edx],18,NULL,NULL,NULL,NULL,NULL,NULL
        xor     eax,eax
        dec     eax
        invoke  ExitProcess,eax
        ret

VDDTerminateVDM endp

MGetVdmPointer   proc InAddress:DWORD,AddrSize:DWORD,IsPM:DWORD

        .if IsPM==FALSE
                push    edx
                mov     eax,InAddress
                mov     dword ptr[CallBuffer],eax
                mov     edx,hFileView
                invoke  DeviceIoControl,[edx],14,addr CallBuffer,4,\
                        addr ReturnValue,4,NULL,NULL
                mov     eax,ReturnValue
                pop     edx
        .else
                xor     eax,eax
        .endif
        ret

MGetVdmPointer   endp

GetINBHandler   proc

        push    ebx
        mov     ebx,hFileView
        mov     eax,dword ptr[ebx+04h]
        pop     ebx
        ret

GetINBHandler   endp

GetOUTBHandler  proc

        push    ebx
        mov     ebx,hFileView
        mov     eax,dword ptr[ebx+08h]
        pop     ebx
        ret

GetOUTBHandler  endp

GetCreateHandler        proc

        push    ebx
        mov     ebx,hFileView
        mov     eax,dword ptr[ebx+10h]
        pop     ebx
        ret

GetCreateHandler        endp

GetDestroyHandler       proc

        push    ebx
        mov     ebx,hFileView
        mov     eax,dword ptr[ebx+14h]
        pop     ebx
        ret

GetDestroyHandler       endp

GetDMAHandler   proc
        
        push    ebx
        mov     ebx,hFileView
        mov     eax,dword ptr[ebx+0ch]
        pop     ebx
        ret

GetDMAHandler   endp

getAF   proc
getAF   endp
getAH   proc
getAH   endp
getAL   proc
getAL   endp
getAX   proc
        invoke  vGetRegister,01h
        ret
getAX   endp
getBX   proc
        invoke  vGetRegister,05h
        ret
getBX   endp
getDS   proc
        invoke  vGetRegister,15h
        ret
getDS   endp
getSI   proc
        invoke  vGetRegister,17h
        ret
getSI   endp
getDX   proc
        invoke  vGetRegister,0dh
        ret
getDX   endp
getCS   proc
        invoke  vGetRegister,1bh
        ret
getCS   endp
getES   proc
        invoke  vGetRegister,18h
        ret
getES   endp
getEIP  proc
        invoke  vGetRegister,1ch
        ret
getEIP  endp
setCF   proc value:DWORD
        ret
setCF   endp
getBP   proc
        invoke  vGetRegister,14h
        ret
getBP   endp
setAX   proc value:DWORD
        invoke  vSetRegister,01h,value
        ret
setAX   endp
getBH   proc
getBH   endp
getBL   proc
getBL   endp
getBH   proc
getBH   endp
getCF   proc
getCF   endp
getCH   proc
getCH   endp
getCL   proc
getCL   endp
getCX   proc
getCX   endp
getDF   proc
getDF   endp
getDH   proc
getDH   endp
getDI   proc
getDI   endp
getDL   proc
getDL   endp
getEAX  proc
getEAX  endp
getEBP  proc
getEBP  endp
getEBX  proc
getEBX  endp
getECX  proc
getECX  endp
getEDI  proc
getEDI  endp
getEDX  proc
getEDX  endp
getESI  proc
getESI  endp
getESP  proc
getESP  endp
getIF   proc
getIF   endp
getIP   proc
getIP   endp
getOF   proc
getOF   endp
getPF   proc
getPF   endp
getSF   proc
getSF   endp
getSP   proc
getSP   endp
getSS   proc
getSS   endp
getZF   proc
getZF   endp
setAF   proc
setAF   endp
setAH   proc
setAH   endp
setAL   proc
setAL   endp
setBX   proc
setBX   endp
setDS   proc
setDS   endp
setSI   proc
setSI   endp
setDX   proc
setDX   endp
setCS   proc
setCS   endp
setES   proc
setES   endp
setEIP  proc
setEIP  endp
setBP   proc
setBP   endp
setBH   proc
setBH   endp
setBL   proc
setBL   endp
setBH   proc
setBH   endp
setCH   proc
setCH   endp
setCL   proc
setCL   endp
setCX   proc
setCX   endp
setDF   proc
setDF   endp
setDH   proc
setDH   endp
setDI   proc
setDI   endp
setDL   proc
setDL   endp
setDX   proc
setDX   endp
setEAX  proc
setEAX  endp
setEBP  proc
setEBP  endp
setEBX  proc
setEBX  endp
setECX  proc
setECX  endp
setEDI  proc
setEDI  endp
setEDX  proc
setEDX  endp
setESI  proc
setESI  endp
setESP  proc
setESP  endp
setIF   proc
setIF   endp
setIP   proc
setIP   endp
setOF   proc
setOF   endp
setPF   proc
setPF   endp
setSF   proc
setSF   endp
setSP   proc
setSP   endp
setSS   proc
setSS   endp
setZF   proc
setZF   endp

abcdefg proc
        mov     edx,ecx
        mov     esi,edi
        mov     edi,[ebp+18h]
        shr     ecx,2
        cmp     esi,0d6000000h
        jae     alreadybig
        add     esi,0d6000000h
alreadybig:
        ret
abcdefg endp


end DllEntry
